import { createSlice } from '@reduxjs/toolkit'

export const wolSlice = createSlice({
    name: 'wol',
    initialState: {
        value: []
    },
    reducers: {
        increment: state => {
            // Redux Toolkit 允许我们在 reducers 写 "可变" 逻辑。它
            // 并不是真正的改变状态值，因为它使用了 Immer 库
            // 可以检测到“草稿状态“ 的变化并且基于这些变化生产全新的
            // 不可变的状态
            state.value += 1
        },
        
        decrement: (state, action) => {
            state.value += action.payload
        },
        incrementByAmount: (state, action) => {
            state.value += action.payload
        },
        //更新数据
        wolupdata: (state, action) => {
            state.value = JSON.parse(JSON.stringify(action.payload))
        },
        //删除id
        delitem: (state, action) => {
            state.value = state.value.splice(state.value.findIndex(item => item.id === action), 1)
        }
    }
})
// 每个 case reducer 函数会生成对应的 Action creators
export const { increment, decrement, incrementByAmount, wolupdata,delitem } = wolSlice.actions

export default wolSlice.reducer